import std/tables
import NimQml


type
  RoleNames {.pure.} = enum
    CustomRole = UserRole + 1,

QtObject:
  type
    TableModel* = ref object of QAbstractTableModel
      customData*: seq[seq[int]]

  proc delete(self: TableModel) =
    self.QAbstractTableModel.delete

  proc setup(self: TableModel) =
    self.QAbstractTableModel.setup

  proc newTableModel*(): TableModel =
    new(result, delete)
    result.customData =  @[@[1,2,3],@[4,5,6],@[7,8,9]]
    result.setup

  method rowCount(self: TableModel, index: QModelIndex = nil): int =
    return self.customData.len # rowCountCallback works

  method columnCount(self: TableModel, index: QModelIndex = nil): int =
    return 3 # columnCountCallback works

  method data(self: TableModel, index: QModelIndex, role: int): QVariant =
    assert(false) # never reached. Crash on indexCallback

  method roleNames(self: TableModel): Table[int, string] =
    {RoleNames.CustomRole.int: "customrole"}.toTable